//
//  ivr4pengine_h
//  MyTest4
//
//  Created by 孙桂山 on 2017/12/10.
//  Copyright © 2017年 孙桂山. All rights reserved.
//

#ifndef ivr4pengine_h
#define ivr4pengine_h

#include <stdio.h>

#if defined(__cplusplus)
extern "C"
{
#endif

    typedef int (* GetSensorQuat)(int iTimeMS, float fQuat[4]);

    typedef int (* GetSensorMat)(int iTimeMS, float fMat[4][4]);
    
    bool  V4_RegLicense(const char * strLicenseID, const char * strKey);
	
    bool  V4_HaveLicense(void);
	
    bool  V4_HaveLicenseCurFile(void);
	
    long  V4_GetVersionID(void);

    long  V4_InitVR4PWithSensor(const char * strFolder,GetSensorQuat _GetQuatFunc);

    long  V4_InitVR4PWithSensorM(const char * strFolder,GetSensorMat _GetMatFunc);

    void  V4_UninitVR4P(void);

    bool  V4_NeedRenderVR();

    void  V4_SetVsyncType(int iVsyncType);

    void V4_UseFrontBuffer(bool bFrontBuffer);

    bool V4_IsFrontBuffer();

    bool  V4_Is3DVRF(const char * strSourceName);

    long  V4_GetResolution(void);

    long  V4_GetResolutionF(const char * strSourceName);

    long  V4_GetMaxPosF(const char * strSourceName);

    long  V4_PlayVRV(const char * strSourceName,const char * strIP,int iPort, bool bLooping, const char * strUserIDOrOtherInfo);
    
    long  V4_SvrVrvState(void);

    long  V4_GetAudioType(void);

    bool  V4_Is3DVR(void);

    void  V4_StopVRV(void);

    bool  V4_IsPlaying(void);

    void  V4_PauseVRV(bool bPlay);

    void  V4_ResizeMyGL(int width, int height);


#define  g_iRenderScene_NoGlass  0
#define  g_iRenderScene_VRLeft   1
#define  g_iRenderScene_VRRight  2

    bool   V4_RenderScene(int iType);

    void   V4_PreRender(void);
    
    void   V4_AftRender(void);

    void   V4_ReleaseGLTexUpdatePT(void);

    int64_t V4_ResetGLTexUpdatePT(void);
    
    void   V4_ReleaseGLRes(void);

    void   V4_ResetGLRes(void);

    void   V4_SeekPos(long lTimeValue, int iLab);

    long   V4_GetPos(void);

    long   V4_GetMaxPos(void);
    
    float  V4_GetPitchAngle(void);
    
    void   V4_SetPitchAngle(float fPitchAngle);
    
    float  V4_GetRotateAngle(void);

    void   V4_SetRotateAngle(float fYawAngle);

    float  V4_ComputeYawAngle(float fx1, float fy1, float fx2, float fy2);

#define  g_iDirType_Font   0
#define  g_iDirType_Back   1
#define  g_iDirType_Right  2
#define  g_iDirType_Left   3
#define  g_iDirType_Up     4
#define  g_iDirType_Down   5
#define  g_iDirType_Camera 6

    void   V4_GetDir(int iType, float fResultDir[3]);

    bool   V4_Render3DUI(bool bLeftEye, float fEyeOffset, float f3DRectPos[12], bool bOpacity, float fOpacity, int iTextureHandle);
    
    bool   V4_Render3DUITexCoord(bool bLeftEye, float fEyeOffset, float f3DRectPos[12], bool bOpacity, float fOpacity, int iTextureHandle,float fTexCoordX,float TexCoordY,float TexCoordWidth,float TexCoordHeight);
    
    bool   V4_Render3DUI2(bool bLeftEye, float fEyeOffset, float f3CenterPos[3], float f3FaceDir[3], float fWidth, float fHeight, float fRotateAngle, bool bOpacity, float fOpacity, int iTextureHandle);
    
    bool   V4_Render3DUI2TexCoord(bool bLeftEye, float fEyeOffset, float f3CenterPos[3], float f3FaceDir[3], float fWidth, float fHeight, float fRotateAngle, bool bOpacity, float fOpacity, int iTextureHandle,float fTexCoordX,float TexCoordY,float TexCoordWidth,float TexCoordHeight);
    
    bool   V4_Render3DProgressCircle(bool bLeftEye, float fEyeOffset, float f3CenterPos[3], float f3FaceDir[3], float fWidth, float fRotateAngle, float fOpacity,  int iTextureHandle);

    bool   V4_Render2DUI(float fCenterXInP, float fCenterYInP, float fWidthInP, float fHeightInP,float fRotateAngle, bool bOpacity, float fOpacity, int iTextureHandle);

    bool   V4_Render2DUITexCoord(float fCenterXInP, float fCenterYInP, float fWidthInP, float fHeightInP,float fRotateAngle, bool bOpacity, float fOpacity, int iTextureHandle,float fTexCoordX,float TexCoordY,float TexCoordWidth,float TexCoordHeight);
    
    void   V4_CfgSetRenderBKRed(bool bRed);

    void   V4_CfgSetUseDynamicIntensity(bool bUse);

    bool   V4_CfgGetUseDynamicIntensity();

    void   V4_CfgSetColorShift(bool bShift);

    bool   V4_CfgGetColorShift();

    void   V4_CfgSetCenterBlackWidth(int iWidth);

    int    V4_CfgGetCenterBlackWidth(void);
    
    void   V4_CfgSetSensorMode(bool bLockSensor);
    
    bool   V4_CfgGetSensorMode(void);
    
    void   V4_CfgSetGlassMode(bool bGlassMode);

    bool   V4_CfgGetGlassMode(void);

    void   V4_CfgSetGlassViewPortScale(float fScale);

    float  V4_CfgGetGlassViewPortScale(void);

    void   V4_CfgSetCenterOffset(int iOffsetH, int iOffsetV);

    int    V4_CfgGetCenterOffsetH(void);

    int    V4_CfgGetCenterOffsetV(void);
    
    int    V4_CfgComCenterOffsetVByPupiDis(float fPupiDis, float fScreenSize);
    
    void   V4_CfgSetGlassViewPortRotate(int iRotateType);
    
    int    V4_CfgGetGlassViewPortRotate();

    void   V4_CfgSetFovV(float fFovV);

    float  V4_CfgGetFovV(void);

    void   V4_CfgSetUndistortParam(float Undistort1, float Undistort2);

    float  V4_CfgGetUndistortParam1(void);

    float  V4_CfgGetUndistortParam2(void);
    
#define  g_iRenderFPS_60   0
#define  g_iRenderFPS_75   1
#define  g_iRenderFPS_90   2
#define  g_iRenderFPS_120  3
#define  g_iRenderFPS_150  4
#define  g_iRenderFPS_72   5
#define  g_iRenderFPS_80   6
#define  g_iRenderFPS_144  7
    
    void   V4_CfgSetRenderFPSForOP(int iRenderFPS);
    
    void   V4_CfgSetVolume(float fParam);
    
    float  V4_CfgGetVolume();
        
    bool   V4_GetFrameImageData(const char * strFileName, long lPos, long lImageWidth, long lImageHeight, float fFovInRadian, float fCameraDir[3], bool bReverseImage, bool bReverseRGB,uint8_t * pResult);
    
    bool   V4_GetFrameImageDataB(const char * strFileName, long lPos, long lImageWidth,bool bReverseImage, bool bReverseRGB, uint8_t * pResult);
    
#if defined(__cplusplus)
}
#endif

#endif






