package com.vr4p.admin.vr4pnativedemo;

import android.content.Context;
import android.os.Bundle;
import android.app.NativeActivity;

import com.vr4p.admin.lib.VREngine;

import java.io.File;

public class MainActivity extends NativeActivity
{
    static {
        System.loadLibrary("vr4p-sample-lib");
    }

    File        fExtFileDir;

    String      strExtFileDir;

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        //===========================================================================================
        //开启或关闭FrontBuffer的关键性设置；
        //===========================================================================================
        VREngine.UseFrontBuffer(false);
        VREngine.InitVsyncPulse();
        VREngine.SetVsyncType(VREngine.g_iRenderScene_Other);

        //=================================================================================================
        //关闭这项功能 VREngine.UseFrontBuffer(false);  同时去掉InitVsyncPulse UnitVsyncPulse两个接口的调用
        //=================================================================================================

        Context context = getApplicationContext();
        try
        {
            fExtFileDir=context.getExternalFilesDir(null);
            assert fExtFileDir != null;
            if(!fExtFileDir.exists())
                fExtFileDir.mkdirs();
            strExtFileDir = fExtFileDir.getAbsolutePath();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

        //==============================================================================================================
        //设置VR头盔模式，VR一体机、VR盒子，都必须设置为true；无VR盒子时用手机观看设置为false
        VREngine.CfgSetGlassMode(true); //VREngine.CfgSetGlassMode(false);

        //==============================================================================================================
        //设置FOV， 这里是弧度，所以需要转化；往往比VR头盔标注的FOV小
        //VREngine.CfgSetFovV(3.14159265f * 88.0f / 180.0f);
        //VREngine.CfgSetFovV(3.14159265f * 90.0f / 180.0f);
        //VREngine.CfgSetFovV(3.14159265f * 91.0f / 180.0f);

        VREngine.CfgSetFovV(3.14159265f * 80.0f / 180.0f);

        //VREngine.CfgSetRenderBKRed(true);
        //==============================================================================================================
        //设置畸变修正参数，   公式为： 1 + K1 * R * R + K2 * R * R * R * R     K1   K2 为参数；由于R的单位不一样，所以K1 K2的跟你们以前的设置的值可能不一样
        VREngine.CfgSetUndistortParam(0.20f, 0.0f);

        //==============================================================================================================
        //缩放显示区域的大小（圆的直径），透过头盔刚好看到圆黑边为最佳，既不浪费CPU，又达到视野最大；
        VREngine.CfgSetGlassViewPortScale(1.05f);

        //==============================================================================================================
        //屏幕显示修正；0表示不旋转，1表示逆时针旋转90度，2表示顺时针旋转90度，3表示旋转180度
        VREngine.CfgSetGlassViewPortRotate(0);

        //==============================================================================================================
        //设置中间不显示区域的宽度，主要是手机上，VR盒子与手机屏幕有缝，不设置一定宽度，左眼可能透过缝看到右屏，一体机一般可以设置小一些甚至0
        VREngine.CfgSetCenterBlackWidth(6);

        //==============================================================================================================
        // 打开色散修正功能；
        VREngine.CfgSetColorShift(true);

        //==============================================================================================================
        //设置显示区域中心点的偏移， 在水平方向主要是与瞳距匹配； 一般CfgComCenterOffsetVByPupiDis返回的就是比较合适的瞳距
        //但如果头盔的瞳距 S1 跟人的瞳距 S0 不一致，还是需要通过调整iOffsetInPixel来进行修正

        VREngine.CfgSetCenterOffset(0, 0);

        Bundle bundle = this.getIntent().getExtras();
        String  strVRVFileName = strExtFileDir;
        strVRVFileName += "/Test.vrb";
        VREngine.PlayVRV(strVRVFileName,"",0,true,"");
    }

    protected void onDestroy()
    {
        VREngine.UnitVsyncPulse();
        super.onDestroy();
    }
}





